<template>
  <div>
    <div>

      <h1>Dodaj zbiór:</h1>

      <form
          v-on:submit.prevent="submitForm"
      >

        <div class="form-group">

          <div v-if="wasSubmitted && !form.collectionDate">
            <p style="color: red;">Uzupełnij: </p>
          </div>

          <label for="collectionDate">Data zbioru:</label>
          <vue-englishdatepicker id="collectionDate" v-model="form.collectionDate"/>
        </div>

        <div class="form-group">
          <label for="honeyType">Rodzaj zebranego miodu:</label>
          <input type="text" class="form-control" id="honeyType" placeholder="Rodzaj miodu"
                 v-model="form.honeyType" required max="30">
        </div>

        <div class="form-group">

          <div v-if="wasSubmitted && !form.amount">
            <p style="color: red;">Uzupełnij: </p>
          </div>

          <label for="amount">Ilość miodu:</label>
          <vue-slider
              id="amount"
              style="width: 500px"
              :max="50"
              v-model="form.amount"
          />
          {{ form.amount }}l.
        </div>

        <div class="form-group">
          <button class="btn btn-primary">Dodaj</button>
        </div>
      </form>
    </div>

  </div>
</template>

<script>
import HoneycollectionService from '../../services/honeycollection.service';
import honeycollectionobject from "@/models/honeycollectionobject";
import VueEnglishdatepicker from 'vue-englishdatepicker';

import VueSlider from 'vue-slider-component'
import 'vue-slider-component/theme/antd.css'

export default {
  name: 'AddHoneyCollection',
  components: {
    VueEnglishdatepicker,
    VueSlider
  },
  data() {
    return {
      content: '',
      form: new honeycollectionobject('', '', '', ''),
      wasSubmitted: false,
    };
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  mounted() {

  },
  methods: {
    submitForm() {

      if (!this.currentUser) {
        this.$router.push('/login');
      } else {

        this.wasSubmitted = true


        if (!this.currentUser) {
          this.$router.push('/login');
        } else if (this.$route.query.beehiveId) {

          if (this.checkObject()) {

            this.form.beehiveId = this.$route.query.beehiveId;


            HoneycollectionService.addNewHoneyCollection(this.form).then(
                response => {
                  this.content = response.data;

                  alert('Zbiór dodany poprawnie!')

                  this.$router.push('/beehive?beehiveid=' + this.$route.query.beehiveId)

                },
                error => {
                  this.content =
                      (error.response && error.response.data && error.response.data.message) ||
                      error.message ||
                      error.toString();
                }
            );
          } else
            alert('Uzupełnij brakujące dane!')
        }
      }
    },

    checkObject() {
      if (
          !this.form.collectionDate ||
          !this.form.amount ||
          !this.form.honeyType
      )
        return false
      else
        return true
    }
  }
};
</script>

<style scoped>
label {
  display: block;
  margin-top: 10px;
}
</style>